Index: pjproject/trunk/pjlib/include/pj/config_site_sample.h
===================================================================
--- pjproject/trunk/pjlib/include/pj/config_site_sample.h	(revision 2677)
+++ pjproject/trunk/pjlib/include/pj/config_site_sample.h	(revision 2678)
@@ -50,6 +50,15 @@
     #define PJMEDIA_HAS_SPEEX_AEC		0
 
-    /* Shouldn't use resampling for performance reason too. */
-    #define PJMEDIA_RESAMPLE_IMP		PJMEDIA_RESAMPLE_NONE
+    /* Previously, resampling is disabled due to performance reason and
+     * this condition prevented some 'light' wideband codecs (e.g: G722.1)
+     * to work along with narrowband codecs. Lately, some tests showed
+     * that 16kHz <-> 8kHz resampling using libresample small filter was 
+     * affordable on ARM9 260 MHz, so here we decided to enable resampling.
+     * Note that it is important to make sure that libresample is created
+     * using small filter. For example PJSUA_DEFAULT_CODEC_QUALITY must
+     * be set to 3 or 4 so pjsua-lib will apply small filter resampling.
+     */
+    //#define PJMEDIA_RESAMPLE_IMP		PJMEDIA_RESAMPLE_NONE
+    #define PJMEDIA_RESAMPLE_IMP		PJMEDIA_RESAMPLE_LIBRESAMPLE
 
     /* Use the lighter WSOLA implementation */
@@ -71,6 +80,8 @@
      */
 
-    /* Default codec (Speex) quality */
-    #define PJSUA_DEFAULT_CODEC_QUALITY		5
+    /* Default codec quality, previously was set to 5, however it is now
+     * set to 4 to make sure pjsua instantiates resampler with small filter.
+     */
+    #define PJSUA_DEFAULT_CODEC_QUALITY		4
 
     /* Set maximum number of objects to minimum to reduce memory usage */
Index: pjproject/trunk/pjsip-apps/src/pjsua_wince/pjsua_wince.cpp
===================================================================
--- pjproject/trunk/pjsip-apps/src/pjsua_wince/pjsua_wince.cpp	(revision 2677)
+++ pjproject/trunk/pjsip-apps/src/pjsua_wince/pjsua_wince.cpp	(revision 2678)
@@ -384,5 +384,6 @@
     media_cfg.ec_options = PJMEDIA_ECHO_SIMPLE;
     media_cfg.ec_tail_len = 256;
-    media_cfg.quality = 1;
+    // use default quality setting
+    //media_cfg.quality = 1;
     media_cfg.ptime = 20;
     media_cfg.enable_ice = USE_ICE;
Index: pjproject/trunk/pjsip-apps/src/pocketpj/PocketPJDlg.cpp
===================================================================
--- pjproject/trunk/pjsip-apps/src/pocketpj/PocketPJDlg.cpp	(revision 2677)
+++ pjproject/trunk/pjsip-apps/src/pocketpj/PocketPJDlg.cpp	(revision 2678)
@@ -177,5 +177,6 @@
     media_cfg.ilbc_mode = 30;
     media_cfg.max_media_ports = 8;
-    media_cfg.quality = 5;
+    // use default quality setting
+    //media_cfg.quality = 5;
     media_cfg.thread_cnt = 1;
     media_cfg.enable_ice = m_Cfg.m_UseIce;
Index: pjproject/trunk/third_party/build/g7221/libg7221codec.vcproj
===================================================================
--- pjproject/trunk/third_party/build/g7221/libg7221codec.vcproj	(revision 2677)
+++ pjproject/trunk/third_party/build/g7221/libg7221codec.vcproj	(revision 2678)
@@ -577,4 +577,5 @@
 				Name="VCCLCompilerTool"
 				ExecutionBucket="7"
+				Optimization="2"
 				AdditionalIncludeDirectories="../..;../../g7221/common;../../../pjlib/include"
 				PreprocessorDefinitions="_LIB;"
@@ -644,4 +645,5 @@
 				Name="VCCLCompilerTool"
 				ExecutionBucket="7"
+				Optimization="2"
 				AdditionalIncludeDirectories="../..;../../g7221/common;../../../pjlib/include"
 				PreprocessorDefinitions="_LIB;"
@@ -711,4 +713,5 @@
 				Name="VCCLCompilerTool"
 				ExecutionBucket="7"
+				Optimization="2"
 				AdditionalIncludeDirectories="../..;../../g7221/common;../../../pjlib/include"
 				PreprocessorDefinitions="_LIB;"
@@ -778,4 +781,5 @@
 				Name="VCCLCompilerTool"
 				ExecutionBucket="7"
+				Optimization="2"
 				AdditionalIncludeDirectories="../..;../../g7221/common;../../../pjlib/include"
 				PreprocessorDefinitions="_LIB;"
@@ -845,4 +849,5 @@
 				Name="VCCLCompilerTool"
 				ExecutionBucket="7"
+				Optimization="2"
 				AdditionalIncludeDirectories="../..;../../g7221/common;../../../pjlib/include"
 				PreprocessorDefinitions="_LIB;"
@@ -912,4 +917,5 @@
 				Name="VCCLCompilerTool"
 				ExecutionBucket="7"
+				Optimization="2"
 				AdditionalIncludeDirectories="../..;../../g7221/common;../../../pjlib/include"
 				PreprocessorDefinitions="_LIB;"
@@ -1037,4 +1043,5 @@
 				Name="VCCLCompilerTool"
 				ExecutionBucket="7"
+				Optimization="2"
 				AdditionalIncludeDirectories="../..;../../g7221/common;../../../pjlib/include"
 				PreprocessorDefinitions="_LIB;"
@@ -1104,4 +1111,5 @@
 				Name="VCCLCompilerTool"
 				ExecutionBucket="7"
+				Optimization="2"
 				AdditionalIncludeDirectories="../..;../../g7221/common;../../../pjlib/include"
 				PreprocessorDefinitions="_LIB;"
@@ -1171,4 +1179,5 @@
 				Name="VCCLCompilerTool"
 				ExecutionBucket="7"
+				Optimization="2"
 				AdditionalIncludeDirectories="../..;../../g7221/common;../../../pjlib/include"
 				PreprocessorDefinitions="_LIB;"
@@ -1238,4 +1247,5 @@
 				Name="VCCLCompilerTool"
 				ExecutionBucket="7"
+				Optimization="2"
 				AdditionalIncludeDirectories="../..;../../g7221/common;../../../pjlib/include"
 				PreprocessorDefinitions="_LIB;"
@@ -1305,4 +1315,5 @@
 				Name="VCCLCompilerTool"
 				ExecutionBucket="7"
+				Optimization="2"
 				AdditionalIncludeDirectories="../..;../../g7221/common;../../../pjlib/include"
 				PreprocessorDefinitions="_LIB;"
@@ -1372,4 +1383,5 @@
 				Name="VCCLCompilerTool"
 				ExecutionBucket="7"
+				Optimization="2"
 				AdditionalIncludeDirectories="../..;../../g7221/common;../../../pjlib/include"
 				PreprocessorDefinitions="_LIB;"
@@ -1497,4 +1509,5 @@
 				Name="VCCLCompilerTool"
 				ExecutionBucket="7"
+				Optimization="2"
 				AdditionalIncludeDirectories="../..;../../g7221/common;../../../pjlib/include"
 				PreprocessorDefinitions="_LIB;"
@@ -1564,4 +1577,5 @@
 				Name="VCCLCompilerTool"
 				ExecutionBucket="7"
+				Optimization="2"
 				AdditionalIncludeDirectories="../..;../../g7221/common;../../../pjlib/include"
 				PreprocessorDefinitions="_LIB;"
@@ -1631,4 +1645,5 @@
 				Name="VCCLCompilerTool"
 				ExecutionBucket="7"
+				Optimization="2"
 				AdditionalIncludeDirectories="../..;../../g7221/common;../../../pjlib/include"
 				PreprocessorDefinitions="_LIB;"
@@ -1698,4 +1713,5 @@
 				Name="VCCLCompilerTool"
 				ExecutionBucket="7"
+				Optimization="2"
 				AdditionalIncludeDirectories="../..;../../g7221/common;../../../pjlib/include"
 				PreprocessorDefinitions="_LIB;"
@@ -1765,4 +1781,5 @@
 				Name="VCCLCompilerTool"
 				ExecutionBucket="7"
+				Optimization="2"
 				AdditionalIncludeDirectories="../..;../../g7221/common;../../../pjlib/include"
 				PreprocessorDefinitions="_LIB;"
@@ -1832,4 +1849,5 @@
 				Name="VCCLCompilerTool"
 				ExecutionBucket="7"
+				Optimization="2"
 				AdditionalIncludeDirectories="../..;../../g7221/common;../../../pjlib/include"
 				PreprocessorDefinitions="_LIB;"
